Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.value
Class AnyURIValue

    java.lang.Object
      net.sf.saxon.value.Value
          net.sf.saxon.value.AtomicValue
              net.sf.saxon.value.StringValue
                  net.sf.saxon.value.AnyURIValue

All Implemented Interfaces:
  Serializable, Comparable, SequenceIterable, Item, ValueRepresentation

    public final class AnyURIValue

extends StringValue

An XPath value of type xs:anyURI.

This is implemented as a subtype of StringValue even though xs:anyURI is not a subtype of xs:string in the XPath type hierarchy. This enables type promotion from URI to String to happen automatically in most cases where it is appropriate.

This implementation of xs:anyURI allows any string to be contained in the value space. It is possible to validate that the string is a "valid URI" in the sense of XML Schema Part 2 (which refers to the XLink specification and to RFC 2396); however, this validation is optional, and is not carried out by default. In particular, there is no constraint that namespace URIs, collation URIs, and the like should be valid URIs. However, casting from strings to xs:anyURI does invoke validation.

See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class net.sf.saxon.value.StringValue
`StringValue.CharacterIterator`

Field Summary
`static AnyURIValue` | `EMPTY_URI`

Fields inherited from class net.sf.saxon.value.StringValue
`EMPTY_STRING, FALSE, SINGLE_SPACE, TRUE`

Fields inherited from class net.sf.saxon.value.Value
`EMPTY_CLASS_ARRAY, INDETERMINATE_ORDERING`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`AnyURIValue(CharSequence value)` Constructor
`AnyURIValue(CharSequence value, AtomicType type)` Constructor for a user-defined subtype of anyURI

Method Summary
`AtomicValue` | `convertPrimitive(BuiltInAtomicType requiredType, boolean validate, XPathContext context)` Convert to target data type
`Object` | `convertToJava(Class target, XPathContext context)` Convert to Java object (for passing to external functions)
`AtomicValue` | `copy(AtomicType typeLabel)` Create a copy of this atomic value, with a different type label
`boolean` | `equals(Object other)` Determine if two AnyURIValues are equal, according to XML Schema rules.
`BuiltInAtomicType` | `getPrimitiveType()` Determine the primitive type of the value.
`static boolean` | `isValidURI(CharSequence value)` Check whether a string consititutes a valid URI

Methods inherited from class net.sf.saxon.value.StringValue
`codepointEquals, containsSurrogatePairs, contract, convertStringToAtomicType, convertStringToBuiltInType, effectiveBooleanValue, expand, expand, getSchemaComparable, getStringLength, getStringLength, getStringValue, getStringValueCS, getXPathComparable, hashCode, isZeroLength, iterateCharacters, makeRestrictedString, makeStringValue, setStringValueCS, toString`

Methods inherited from class net.sf.saxon.value.AtomicValue
`checkPermittedContents, convert, convert, getCardinality, getComponent, getItemType, getLength, getTypedValue, getTypeLabel, hasBuiltInType, isMultiValued, itemAt, iterate, process, setTypeLabel`

Methods inherited from class net.sf.saxon.value.Value
`asItem, asItem, asIterator, asValue, compareTo, convert, convertJavaObjectToXPath, fromItem, getCanonicalLexicalRepresentation, getIterator, iterate, makeQNameValue, reduce, stringToNumber`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### EMPTY_URI

    public static final AnyURIValue EMPTY_URI

Constructor Detail

### AnyURIValue

    public AnyURIValue(CharSequence value)

  Constructor

  Parameters:
    `value` - the String value. Null is taken as equivalent to "". This constructor does not check that the value is a valid anyURI instance.

### AnyURIValue

    public AnyURIValue(CharSequence value,
                       AtomicType type)

  Constructor for a user-defined subtype of anyURI

  Parameters:
    `value` - the String value. Null is taken as equivalent to "".
    `type` - a user-defined subtype of anyURI. It is the caller's responsibility to ensure that this is actually a subtype of anyURI, and that the value conforms to the definition of this type.

Method Detail

### copy

    public AtomicValue copy(AtomicType typeLabel)

  Create a copy of this atomic value, with a different type label

  Overrides:
    `copy` in class `StringValue`
  Parameters:
    `typeLabel` - the type label of the new copy. The caller is responsible for checking that the value actually conforms to this type.

### isValidURI

    public static boolean isValidURI(CharSequence value)

  Check whether a string consititutes a valid URI

### getPrimitiveType

    public BuiltInAtomicType getPrimitiveType()

  Description copied from class: `StringValue`
  Determine the primitive type of the value. This delivers the same answer as getItemType().getPrimitiveItemType(). The primitive types are the 19 primitive types of XML Schema, plus xs:integer, xs:dayTimeDuration and xs:yearMonthDuration, and xs:untypedAtomic. For external objects, the result is AnyAtomicType.

  Overrides:
    `getPrimitiveType` in class `StringValue`

### convertPrimitive

    public AtomicValue convertPrimitive(BuiltInAtomicType requiredType,
                                        boolean validate,
                                        XPathContext context)

  Convert to target data type

  Overrides:
    `convertPrimitive` in class `StringValue`
  Parameters:
    `requiredType` - integer code representing the item type required
    `context` -
    `validate` - true if validation is required. If set to false, the caller guarantees that the value is valid for the target data type, and that further validation is therefore not required. Note that a validation failure may be reported even if validation was not requested.
  Returns:
    the result of the conversion, or an ErrorValue

### equals

    public boolean equals(Object other)

  Determine if two AnyURIValues are equal, according to XML Schema rules. (This method is not used for XPath comparisons, which are always under the control of a collation.)

  Overrides:
    `equals` in class `StringValue`
  Throws:
    `ClassCastException` - if the values are not comparable

### convertToJava

    public Object convertToJava(Class target,
                                XPathContext context)
                         throws XPathException

  Convert to Java object (for passing to external functions)

  Overrides:
    `convertToJava` in class `StringValue`
  Parameters:
    `target` - the Java class to which conversion is required
  Returns:
    the result of the conversion
  Throws:
    `XPathException` - if conversion to this target type is not possible

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.